class Flags {
   public boolean thread_zero_wants_in = false;
   public boolean thread_one_wants_in = false;
   public boolean thread_zero_spin = false;
   public boolean thread_one_spin = false;
}

class thread_zero implements Runnable {

   private Flags f;

   public thread_zero(Flags f) {
     this.f = f;
   }

   private void critical_region_zero() {
      System.out.println("In CR Zero");
   }

   private void other_stuff_zero() {
      System.out.println("In Other Stuff Zero");
   }

   public void run() {
     while (true) {
       f.thread_zero_wants_in = true;
       while (f.thread_one_wants_in) {
         f.thread_zero_spin = true;
         Thread.yield();
         assert(!(f.thread_one_spin));
         f.thread_zero_spin = false;
       };
       System.out.println("Entering CR Zero");
       critical_region_zero();
       System.out.println("Leaving CR Zero");
       f.thread_zero_wants_in = false;
       other_stuff_zero();
     }
   }
}

class thread_one implements Runnable {

   private Flags f;

   public thread_one(Flags f) {
     this.f = f;
   }

   private void critical_region_one() {
      System.out.println("In CR One");
   }

   private void other_stuff_one() {
      System.out.println("In Other Stuff One");
   }

   public void run() {
     while (true) {
       f.thread_one_wants_in = true;
       while (f.thread_zero_wants_in) {
         f.thread_one_spin = true;
         Thread.yield();
         assert(!(f.thread_zero_spin));
         f.thread_one_spin = false;
       };
       System.out.println("Entering CR One");
       critical_region_one();
       System.out.println("Leaving CR One");
       f.thread_one_wants_in = false;
       other_stuff_one();
     }
   }
}

public class attempt_3 {

   public static void main(String[] args) {
     Flags  f    = new Flags();
     Thread zero = new Thread(new thread_zero(f));
     Thread one  = new Thread(new thread_one(f));

     zero.start();
     one.start();

   }

}
